#
# spec file for package mpich (Version 1.2.1)
# 
# Copyright  (c)  2001  SuSE GmbH  Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
# 
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild  g77 gdb gnuplot gpp java libgpp
# usedforbuild    aaa_base aaa_dir autoconf automake base bash bindutil binutils bison bzip compress cpio cpp cracklib cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex g77 gawk gcc gdb gdbm gdbm-devel gettext glibc glibc-devel gnuplot gpm gpp gppshare grep groff gzip java kbd less libgpp libtool libz m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam pam-devel patch perl ps rcs readline rpm sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim

Name:         mpich
Copyright:    redistributable
Group:        Development/Libraries/Parallel
Url:		http://www-unix.mcs.anl.gov/mpi/mpich/
Version:      1.2.1
Release:      156
Summary:      A Portable Implementation of MPI
Source:       mpich-%{version}.tar.bz2
Source1:       mpich.module
Patch:	      mpich-%{version}.dif
Patch1:	      patch.all
Patch2:	      va_arg.patch
Prefix:		/usr/lib
BuildRoot:	%{_tmppath}/mpich-root
Autoreqprov:  on

%description
MPICH is a freely available, portable implementation of MPI, the Standard for message-passing libraries.

Authors:
--------
    Bill Gropp <gropp@mcs.anl.gov>
    Rusty Lusk <lusk@mcs.anl.gov>

SuSE series: beo

%package manpages
Conflicts:    lam-manpages
Summary:      MPICH manpages
Provides:	mpichman
Obsoletes:	mpichman
Group:        Documentation
Autoreqprov:  on

%description manpages
Manpages of the portable implementation of MPI (MPICH).

Authors:
--------
    Bill Gropp <gropp@mcs.anl.gov>
    Rusty Lusk <lusk@mcs.anl.gov>

SuSE series: beo

%prep
%setup -q
%patch1
%patch2
%patch
DIRS=$(find -type d)
%{?suse_update_config:%{suse_update_config -f $DIRS}}

%build
./configure --prefix=%{prefix}/mpich -arch=LINUX -device=ch_p4 -comm=ch_p4 --fc=/usr/bin/g77  --enable-debug --enable-sharedlib -usesysv --docdir=%{_defaultdocdir}/mpich 
make

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT docdir=$RPM_BUILD_ROOT%{_defaultdocdir} sysconfdir=$RPM_BUILD_ROOT/etc/mpich 
echo "Customizing.."
install -d $RPM_BUILD_ROOT/etc/mpich
cp $RPM_BUILD_ROOT%{prefix}/mpich/share/machines.LINUX $RPM_BUILD_ROOT/etc/mpich
ln -sf /etc/mpich/machines.LINUX $RPM_BUILD_ROOT%{prefix}/mpich/share 
install -d $RPM_BUILD_ROOT/usr/share/modules/modulefiles
install -m 0644 %{SOURCE1} $RPM_BUILD_ROOT/usr/share/modules/modulefiles/mpich
                                 
(
  install -d $RPM_BUILD_ROOT/usr/sbin 
  cd $RPM_BUILD_ROOT/usr/sbin
  ln -sf %{prefix}/mpich/sbin/tstmachines .
  ln -sf %{prefix}/mpich/sbin/chp4_servs .
  ln -sf %{prefix}/mpich/sbin/chkserv .
  ln -sf %{prefix}/mpich/sbin/cleanipcs .
)     
chmod 755 $RPM_BUILD_ROOT%{prefix}/mpich/lib/*.so
(
  install -d $RPM_BUILD_ROOT/usr/bin
  cd $RPM_BUILD_ROOT/usr/bin
  ln -sf %{prefix}/mpich/bin/tarch .
  ln -sf %{prefix}/mpich/bin/serv_p4 .
  ln -sf %{prefix}/mpich/bin/tdevice .
  ln -sf %{prefix}/mpich/bin/execer .
)         
(
cd $RPM_BUILD_ROOT/usr/lib/mpich/lib
ln -sf libmpich.a libmpi.a
cd shared
ln -sf libmpich.so.* libmpich.so
ln -sf libfmpich.so.* libfmpich.so
ln -sf libpmpich.so.* libpmpich.so
chmod +x *.so.*
)
for binfile in `ls $RPM_BUILD_ROOT%{prefix}/mpich/bin | grep -v ^mpi`; do 
    ln -sf ../lib/mpich/bin/$binfile $RPM_BUILD_ROOT/usr/bin/
done
# Uninstall should happen with rpm 
rm $RPM_BUILD_ROOT%{prefix}/mpich/sbin/mpiuninstall
find $RPM_BUILD_ROOT/usr/lib/mpich -type f | xargs perl -pi -e 's#/var/tmp/mpich-root##' 
find $RPM_BUILD_ROOT/usr/lib/mpich -name "mpi*" -type f | xargs perl -pi -e 's#/usr/src/packages/BUILD/mpich-1.2.1#/usr/lib/mpich#' 
rm $RPM_BUILD_ROOT/usr/lib/mpich/share/examples/mpirun

%clean 
rm -rf $RPM_BUILD_ROOT

%files
%doc COPYRIGHT KnownBugs README doc/guide.ps.gz www/* 
/usr/lib/mpich
/usr/sbin/*
/usr/bin/*
%config /etc/mpich/machines.LINUX
%config /usr/share/modules/modulefiles/mpich

%files manpages
/usr/share/man/man1/*
/usr/share/man/man3/*
/usr/share/man/man4/*

%changelog -n mpich
* Thu Apr 12 2001 - nashif@suse.de
- Applied cummulative patches upto bug #5906
* Wed Mar 07 2001 - nashif@suse.de
- Fixed order of patches in spec file
- Fixed script in spec to link binaries in /usr/bin
* Tue Mar 06 2001 - nashif@suse.de
- Update with latest patches (patch.all)
- removed all mpi* from /usr/bin (Conflicts with other MPIs)
- Added mpich module configuration file for (module load mpich), which
  requires environment-modules package.
- Fixed shared lib path in mpif77,90
* Tue Mar 06 2001 - schwab@suse.de
- Build with --enable-sharedlib to get something that can be linked
  into a shared library.
- Add %%suse_update_config.
* Sat Feb 17 2001 - nashif@suse.de
- Fixed va_arg arguments
- Update to latest patchlevel
* Fri Nov 17 2000 - nashif@suse.de
- Added mpe support
* Thu Nov 16 2000 - nashif@suse.de
- Applied latest cummulative patch
- Changed sub-package name: mpichman -> mpich-manpages
* Sun Oct 29 2000 - nashif@suse.de
- Update to version 1.2.1
* Fri Mar 31 2000 - nadvornik@suse.cz
- removed directories owned by aaa_dir
* Tue Jan 25 2000 - nashif@suse.de
- Applied patches 4992 and 4997
* Mon Jan 17 2000 - nashif@suse.de
- Updated to 1.2.0
- moved manpages to /usr/share
* Sun Nov 07 1999 - nashif@suse.de
-   Organised spec file
-   fixed spec file
* Thu Oct 07 1999 - nashif@suse.de
-   Minor link fixes and directory reloacation
* Thu Sep 30 1999 - nashif@suse.de
-  Added mpichman: a new subpackage for the manual pages to avoid
  conflict with LAM
-  moved configuration files to /etc/mpich
-  Now it should work side by side with LAM
* Tue Sep 28 1999 - nashif@suse.de
-  Removed MPE from package: using old tk
* Mon Sep 27 1999 - nashif@suse.de
-  MPICH - Message Passing Interface Implementation 1.1.2
